//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

//----
string Indicator_Name = "Norm:  ";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 4
//---- parameters


extern int          period=14;
extern int          price=0;


extern bool Cur01 = 1;
extern string       Currency01="GBPUSD";
extern color        Color01=Red;

extern bool Cur02 = 1;
extern string       Currency02="EURUSD";
extern color        Color02=Green;


extern bool Cur03 = 1;
extern string       Currency03="EURJPY";
extern color        Color03=Blue;

extern bool Cur04 = 1;
extern string       Currency04="GBPJPY";
extern color        Color04=Yellow;


extern int          TF=0;   // TF min or 0 for chart TF

extern int          DrawBars=1000;
extern int          Line_Thickness = 2;




//----
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(Cur01)
       Indicator_Name = StringConcatenate(Indicator_Name, Currency01," ");
   if(Cur02)
       Indicator_Name = StringConcatenate(Indicator_Name, Currency02," ");
   if(Cur03)
       Indicator_Name = StringConcatenate(Indicator_Name, Currency03," ");
   if(Cur04)
       Indicator_Name = StringConcatenate(Indicator_Name, Currency04," ");       
   
   Indicator_Name = StringConcatenate(Indicator_Name,TF + "min");
   
   IndicatorShortName(Indicator_Name);

   int cur = 10; 
   int st = 42; 
   if(Cur01)
     {
       sl("~", cur, Color01);
       cur += st;
     }
   if(Cur02)
     {
       sl("~", cur, Color02); 
       cur += st;
     }
   if(Cur03)
     {
       sl("~", cur, Color03);
       cur += st;
     }
   if(Cur04)
     {
       sl("~", cur, Color04);
       cur += st;
     }  
     
//----
   int width = 1;
   if(0 > StringFind(Symbol(), Currency01, 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle(0, DRAW_LINE, DRAW_LINE, width, Color01);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexLabel(0, Currency01); 
   
   if(0 > StringFind(Symbol(), Currency02, 0))
       width = 1;
   else
       width = Line_Thickness;
   SetIndexStyle(1, DRAW_LINE, DRAW_LINE, width, Color02);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexLabel(1, Currency02); 

   if(0 > StringFind(Symbol(), Currency03, 0))
       width = 1;
   else
       width = Line_Thickness;
   SetIndexStyle(2, DRAW_LINE, DRAW_LINE, width, Color03);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexLabel(2, Currency03);
  
   if(0 > StringFind(Symbol(), Currency04, 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle(3, DRAW_LINE, DRAW_LINE, width, Color04);
   SetIndexBuffer(3, ExtMapBuffer4);
   SetIndexLabel(3, Currency04);
  
   

   
    
          
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = 0; i < Objs; i++)
     {
       if(!ObjectDelete(Indicator_Name + i))
           Print("error: code #", GetLastError());
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int  counted_bars=IndicatorCounted();
    if ( counted_bars < 0 ) { Print( "Indicator Error (Counted bars < 0)!" ); return(-1); }
    if ( Bars < 100 ) { Print( "Indicator Error (Bars < 100)!" ); return(-1); }
    if ( DrawBars > Bars - 1 || DrawBars <= 0 ) { DrawBars = Bars - 1; }

//----



//----

    for ( int i = DrawBars; i >= 0; i -- )
    { 
    
     
    
    if(Cur01){
    ExtMapBuffer1[i]=iMomentum(Currency01,TF,period,price,i);
    }
    if(Cur02){
    ExtMapBuffer2[i]=iMomentum(Currency02,TF,period,price,i);
    }
    if(Cur03){    
    ExtMapBuffer3[i]=iMomentum(Currency03,TF,period,price,i);
    }
    if(Cur04){    
    ExtMapBuffer4[i]=iMomentum(Currency04,TF,period,price,i);
    }
       
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|  Subroutines                                                     |
//+------------------------------------------------------------------+
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sl(string sym, int y, color col)
  {
   int window = WindowFind(Indicator_Name);
   string ID = Indicator_Name + Objs;
   Print("ID:", ID);
   int tmp = 10 + y;
   Objs++;
   if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
     {
       //ObjectSet(ID, OBJPROP_CORNER, 1);
       ObjectSet(ID, OBJPROP_XDISTANCE, y + 35);
       ObjectSet(ID, OBJPROP_YDISTANCE, 0);
       ObjectSetText(ID, sym, 18, "Arial Black", col);
     }
  } 
//+------------------------------------------------------------------+


